<?php
 #########################################################################################
 #
 # Nom              : anti-robotic.php
 # Auteur           : Spin0us (spin0us@altern.org)
 # Date de creation : mardi 21 septembre 2004, 16h06
 #
 # Version          : 1.2.0 2005/01/27 08:49 Spin0us
 #
 # Copyright (C) 2004 (Spin0us)
 #
 #########################################################################################

 #########################################################################################
 #
 # Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes
 # de la Licence Publique Gnrale GNU publie par la Free Software Foundation (version 2
 # ou bien toute autre version ultrieure choisie par vous).
 #
 #########################################################################################
 

 ### CONFIGURATION DU SCRIPT ############################################################

 $largeur    = 100; // En pixels
 $hauteur    =  25; // En pixels
 $cache_ttl  =   1; // En minutes (duree de vie des fichiers dans le dossier cache
 $noise_line =   5; // Nombre de lignes de bruit



 #########################################################################################
 ########################### NE RIEN TOUCHER A CE QUI SUIT ###############################
 #########################################################################################



 ### DEBUT DE SCRIPT #####################################################################

 ###
 ### Generation de la chaine de caracteres aleatoires
 ###
 function gen_reg_key() {
 	$key = "";
 	$max_length_reg_key = 5;
 	$chars = array("1","2","3","4","5","6","7","8","9","0");
 	$count = count($chars) - 1;
 	srand((double)microtime()*1000000);
 	for($i = 0; $i < $max_length_reg_key; $i++) $key .= $chars[rand(0, $count)];
 	return($key);
 }
 $code = gen_reg_key();


 ###
 ### Purge des fichiers contenus dans le cache
 ###
 $handle=opendir("cache"); 
 while (false!==($file = readdir($handle))) { 
 	if ($file != "." && $file != "..") {  
 		$diff = (time() - filectime("cache/$file"))/60;
 		if ($diff > $cache_ttl) unlink("cache/$file");
 	} 
 }
 closedir($handle); 
 
 ###
 ### Creation du fichier dans le cache
 ###
 $file = fopen("cache/".md5($code),"a");
 fclose($file);
 
 ###
 ### Creation de l'image
 ###
 $img   = @ImageCreate ($largeur, $hauteur) or die ("Erreur lors de la cration");
 $bgc   = imagecolorallocate($img, mt_rand(235,255), mt_rand(235,255), mt_rand(235,255));
 $black = imagecolorallocate($img, 0, 0, 0);
 imagefilledrectangle($img, 0, 0, $largeur, $hauteur, $bgc);
 
 ###
 ### Ecriture du code (le premier 5 est la taille de la police par dfaut)
 ###
 $hor_pos = mt_rand(5,15);
 for($i=0;$i<strlen($code);$i++) {
	imagestring($img, 5, $hor_pos, mt_rand(2,10), $code[$i], $black);
	$hor_pos += mt_rand(10,20);
 }

 ###
 ### Ajout d'un bruit (pixels multicolores)
 ###
 for($i=0;$i<100;$i++)
	imagesetpixel($img, mt_rand(0,$largeur), mt_rand(0,$hauteur),
	 imagecolorallocate($img, mt_rand(0,255), mt_rand(0,255), mt_rand(0,255)));

 ###
 ### Ajout d'un bruit (lignes de la mme couleur que la police)
 ###
 for($i=0;$i<$noise_line;$i++) {
	if($i<3) {
		$x1=rand(0,$largeur);
		$y1=0;
		$x2=abs($x1-mt_rand(0,5));
		$y2=$hauteur;
	} else {
		$x1=0;
		$y1=rand(0,$hauteur);
		$x2=$largeur;
		$y2=abs($y1-mt_rand(0,5));
	}
	imageline($img, $x1, $y1, $x2, $y2, $black);
 }

 ###
 ### Creation de l'entete
 ###
 header("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); 
 header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); 
 header("Cache-Control: no-store, no-cache, must-revalidate"); 
 header("Cache-Control: post-check=0, pre-check=0", false);
 header("Pragma: no-cache");
 header("Content-Type: image/png");
 imagePNG($img);
 imagedestroy($img);
 
 ### FIN DE SCRIPT #######################################################################
?>